﻿using Syncfusion.JavaScript.Models;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Web;
using System.Web.Mvc;
using System.Web.Script.Serialization;

using System.Data.SqlClient;
using System.Web.Configuration;
using TreeGrid_MVC.Models;


namespace TreeGrid_MVC.Controllers
{
    public class TreegridController : Controller
    {
        //
        // GET: /Treegrid/     
        public ActionResult Index()
        {

            ViewBag.datasource = GanttDefaultData.GetData();                     
            return View();
            //Syncfusion.JavaScript.Models.TreeGridToolBarOptions o = new Syncfusion.JavaScript.Models.TreeGridToolBarOptions();
            //o.ShowToolbar = true;
            //o.ToolbarItems = new List<String>() { "add", "edit", "delete", "update", "cancel", "expandAll", "collapseAll" };
            //List<Syncfusion.JavaScript.Models.TreeGridCustomToolbarItem> cusI = new List<Syncfusion.JavaScript.Models.TreeGridCustomToolbarItem>();
            //Syncfusion.JavaScript.Models.TreeGridCustomToolbarItem a = new Syncfusion.JavaScript.Models.TreeGridCustomToolbarItem();
            //a.Text = "Refresh";
            //a.TemplateID = "ValidateTemplate";
            //a.TooltipText = "refresh";
            //cusI.Add(a);
            //o.CustomToolbarItems = cusI;
            //ViewBag.toolbarSettings = o;
        }
       
        public class GanttDefaultData
        {
            public static List<BusinessObject> GetData()
            {
               
                List<BusinessObject> BusinessObjectCollection = new List<BusinessObject>();
                BusinessObjectCollection.Add(new BusinessObject()
                {
                    TaskId = 1,
                    TaskName = "Parent Task 1",
                    StartDate = "10/23/2017",
                    Duration = 10,
                    Progress = 70,
                    ParentId = 0
                });
                BusinessObjectCollection.Add(new BusinessObject()
                {
                    TaskId = 2,
                    TaskName = "Child task 1",
                    StartDate = "10/23/2017",
                    Duration = 4,
                    Progress = 80,
                    ParentId = 1
                });
                BusinessObjectCollection.Add(new BusinessObject()
                {
                    TaskId = 3,
                    TaskName = "Child Task 2",
                    StartDate = "10/24/2017",
                    Duration = 5,
                    Progress = 65,
                    ParentId = 1
                });
                BusinessObjectCollection.Add(new BusinessObject()
                {
                    TaskId = 4,
                    TaskName = "Child task 3",
                    StartDate = "10/25/2017",
                    Duration = 6,
                    Progress = 77,
                    ParentId = 1
                });
                BusinessObjectCollection.Add(new BusinessObject()
                {
                    TaskId = 5,
                    TaskName = "Parent Task 2",
                    StartDate = "10/23/2017",
                    Duration = 10,
                    Progress = 70,
                    ParentId = 6
                });
                BusinessObjectCollection.Add(new BusinessObject()
                {
                    TaskId = 6,
                    TaskName = "Child task 1",
                    StartDate = "10/23/2017",
                    Duration = 4,
                    Progress = 80,
                    ParentId = 5
                });
                BusinessObjectCollection.Add(new BusinessObject()
                {
                    TaskId = 7,
                    TaskName = "Child Task 2",
                    StartDate = "10/24/2017",
                    Duration = 5,
                    Progress = 65,
                    ParentId = 5
                });
                BusinessObjectCollection.Add(new BusinessObject()
                {
                    TaskId = 8,
                    TaskName = "Child task 3",
                    StartDate = "10/25/2017",
                    Duration = 6,
                    Progress = 77,
                    ParentId = 5
                });
                BusinessObjectCollection.Add(new BusinessObject()
                {
                    TaskId = 9,
                    TaskName = "Child task 4",
                    StartDate = "10/25/2017",
                    Duration = 6,
                    Progress = 77,
                    ParentId = 5
                });
                BusinessObjectCollection.Add(new BusinessObject()
                {
                    TaskId = 10,
                    TaskName = "Parent Task 3",
                    StartDate = "10/23/2017",
                    Duration = 10,
                    Progress = 70,
                    ParentId = 6
                });
                BusinessObjectCollection.Add(new BusinessObject()
                {
                    TaskId = 11,
                    TaskName = "Child task 1",
                    StartDate = "10/23/2017",
                    Duration = 4,
                    Progress = 80,
                    ParentId = 10
                });
                BusinessObjectCollection.Add(new BusinessObject()
                {
                    TaskId = 12,
                    TaskName = "Child Task 2",
                    StartDate = "10/24/2017",
                    Duration = 5,
                    Progress = 65,
                    ParentId = 10
                });
                BusinessObjectCollection.Add(new BusinessObject()
                {
                    TaskId = 13,
                    TaskName = "Child task 3",
                    StartDate = "10/25/2017",
                    Duration = 6,
                    Progress = 77,
                    ParentId = 10
                });
                BusinessObjectCollection.Add(new BusinessObject()
                {
                    TaskId = 14,
                    TaskName = "Child task 4",
                    StartDate = "10/25/2017",
                    Duration = 6,
                    Progress = 77,
                    ParentId = 10
                });
                BusinessObjectCollection.Add(new BusinessObject()
                {
                    TaskId = 15,
                    TaskName = "Child task 5",
                    StartDate = "10/25/2017",
                    Duration = 6,
                    Progress = 77,
                    ParentId = 10
                });

                return BusinessObjectCollection;
            }
        }
       


        #region BusinessObject Creation
        public class BusinessObject
        {
            public int TaskId { get; set; }
            public string TaskName { get; set; }
            public string StartDate { get; set; }
            public int Duration { get; set; }
            public int Progress { get; set; }
            public int ParentId { get; set; }
            public bool IgnoreStock { get; set; }
            public string DailyMax { get; set; }
            public string Jan { get; set; }
            public string Feb { get; set; }
            public string Mar { get; set; }
            public string Apr { get; set; }
            public string May { get; set; }
            public string Jun { get; set; }
            public string Jul { get; set; }
            public string Aug { get; set; }
            public string Sep { get; set; }
            public string Oct { get; set; }
            public string Nov { get; set; }
            public string Dec { get; set; }
            public string Total { get; set; }
            public string DolValue { get; set; }
            public string Notes { get; set; }
            public string Confirm { get; set; }
            public string Projected { get; set; }
            public string Type { get; set; }
            public string Year { get; set; }
            public List<BusinessObject> projRows { get; set; }
        }
        #endregion
    }

}
